﻿using System;
using HeuristicLab.Services.Hive;

namespace HeuristicLab.Clients.Hive.Tests {
  public class MockServiceLocator {
    private string username;
    public string Username {
      get { return username; }
      set { username = value; }
    }

    private string password;
    public string Password {
      get { return password; }
      set { password = value; }
    }

    public HeuristicLab.Services.Hive.Common.ServiceContracts.IHiveService GetService() {
      HiveService service = new HeuristicLab.Services.Hive.HiveService();
      return service;
    }

    public void CallHiveService(Action<HeuristicLab.Services.Hive.Common.ServiceContracts.IHiveService> call) {
      call(GetService());
    }

    public T CallHiveService<T>(Func<HeuristicLab.Services.Hive.Common.ServiceContracts.IHiveService, T> call) {
      return call(GetService());
    }
  }
}
